Bug 1414217 - RFE: Add a server side stub to filter unhashed directories in readdirp
Summary: RFE: Add a server side stub to filter unhashed directories in readdirp
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: GlusterFS
Classification: Community
Component: distribute
Version: mainline
Hardware: Unspecified
OS: Unspecified
low
medium
Target Milestone: ---
Assignee: Poornima G
QA Contact:
URL:
Whiteboard: dht-readdirp-perf
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-01-18 04:38 UTC by Poornima G
Modified: 2019-04-11 07:40 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-04-11 07:40:24 UTC
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:


Attachments (Terms of Use)

Description Poornima G 2017-01-18 04:38:12 UTC
Description of problem:
Currently there are two variations of readdirp:
1. Directories are read from all the bricks and the client filters the duplicate directory entries, by removing the entry if it doesn't hash to the brick that returned the readdirp.
2. dht-readdir-optimise option on: In this case, the directory is read from only one brick(first up subvol) and dht indicates all other bricks to filter the directory entries(at the posix layer)

1- is less performant, while 2 has the problem that some directories can go unlisted if they are not healed to the first up subvol. Hence to get the performance of option 2 and reliability of option 1: we can have a dht stub on the server side which filters the directories in readdirp if they do not hash to that brick. This was proposed by Rghavendra Gowdappa

Version-Release number of selected component (if applicable):


How reproducible:


Steps to Reproduce:
1.
2.
3.

Actual results:


Expected results:


Additional info:

Comment 1 Worker Ant 2017-01-18 04:39:45 UTC
REVIEW: http://review.gluster.org/16312 (dht-server-stub: Add a server side dht to filter the unhashed dir in readdirp) posted (#5) for review on master by Poornima G (pgurusid@redhat.com)

Comment 2 Worker Ant 2017-03-02 09:06:39 UTC
REVIEW: https://review.gluster.org/16824 (dht: move hash calculation code to libglusterfs) posted (#1) for review on release-3.10 by Poornima G (pgurusid@redhat.com)

Comment 3 Worker Ant 2017-03-02 09:06:43 UTC
REVIEW: https://review.gluster.org/16825 (dht-server-stub: Add a server side dht to filter the unhashed dir in readdirp) posted (#1) for review on release-3.10 by Poornima G (pgurusid@redhat.com)

Comment 4 Nithya Balachandran 2019-04-11 07:40:24 UTC
I'm closing this BZ with WontFix. Please reopen the BZ if you feel this should be fixed.


Note You need to log in before you can comment on or make changes to this bug.